datablock TSShapeConstructor(NeotankDts)
{
	baseShape  = "./Neotank.dts";
	sequence0  = "./neo_root.dsq root";

	sequence1  = "./neo_Run.dsq run";
	sequence2  = "./neo_Run.dsq walk";
	sequence3  = "./neo_back.dsq back";
	sequence4  = "./neo_side.dsq side";

	sequence5  = "./neo_root.dsq crouch";
	sequence6  = "./neo_root.dsq crouchRun";
	sequence7  = "./neo_root.dsq crouchBack";
	sequence8  = "./neo_root.dsq crouchSide";

	sequence9  = "./neo_look.dsq look";
	sequence10 = "./neo_root.dsq headside";
	sequence11 = "./neo_root.dsq headUp";

	sequence12 = "./neo_root.dsq jump";
	sequence13 = "./neo_root.dsq standjump";
	sequence14 = "./neo_root.dsq fall";
	sequence15 = "./neo_root.dsq land";

	sequence16 = "./neo_root.dsq armAttack";
	sequence17 = "./neo_root.dsq armReadyLeft";
	sequence18 = "./neo_root.dsq armReadyRight";
	sequence19 = "./neo_root.dsq armReadyBoth";
	sequence20 = "./neo_root.dsq spearready";  
	sequence21 = "./neo_root.dsq spearThrow";

	sequence22 = "./neo_root.dsq talk";  

	sequence23 = "./neo_death.dsq death1"; 
	
	sequence24 = "./neo_root.dsq shiftUp";
	sequence25 = "./neo_root.dsq shiftDown";
	sequence26 = "./neo_root.dsq shiftAway";
	sequence27 = "./neo_root.dsq shiftTo";
	sequence28 = "./neo_root.dsq shiftLeft";
	sequence29 = "./neo_root.dsq shiftRight";
	sequence30 = "./neo_root.dsq rotCW";
	sequence31 = "./neo_root.dsq rotCCW";

	sequence32 = "./neo_root.dsq undo";
	sequence33 = "./neo_root.dsq plant";

	sequence34 = "./neo_root.dsq sit";

	sequence35 = "./neo_root.dsq wrench";
};    


datablock PlayerData(NeotankPlayer)
{
   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./Neotank.dts";
   cameraMaxDist = 10;
   cameraTilt = 0.200;
   cameraVerticalOffset = 2.3;
   computeCRC = false;
  
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 0.5;
   maxFreelookAngle = 3.0;

   mass = 400;
   drag = 0.1;
   density = 10;
   maxDamage = 1500;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 480 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 20;
   maxBackwardSpeed = 12;
   maxSideSpeed = 12;

   maxForwardrootSpeed = 38;
   maxBackwardrootSpeed = 6;
   maxSiderootSpeed = 0;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 28;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 0;

   jumpForce = 64 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("4 4 6.7", 4); 
   rootBoundingBox	= vectorScale("4 4 6.7", 4); 
   proneBoundingBox	= vectorScale("4 4 6.7", 4); 

   pickupRadius = 3;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
	
   jetEmitter = playerJetEmitter;
   jetGroundEmitter = playerJetGroundEmitter;
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   maxStepHeight = 3;
   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= HorseJumpSound;

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Neotank";
	rideable = true;
   lookUpLimit = 0.6;
   lookDownLimit = 0.4;
	useEyePoint = true;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "sit";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = true; //protect passengers from direct damage (bullets) ?

   useCustomPainEffects = true;
   PainHighImage = "";
   PainMidImage  = "";
   PainLowImage  = "";
   painSound     = "";
   deathSound    = "";
};





datablock DebrisData(NeotankDebris)
{
   emitters = "jeepDebrisTrailEmitter";

	shapeFile = "./Neotank.dts";
	lifetime = 3.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


datablock ExplosionData(NeotankExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleExplosionEmitter;
   emitter[1] = vehicleExplosionEmitter2;

   debris = Debris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 18;
   debrisVelocityVariance = 3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   radiusDamage        = 30;
   damageRadius        = 8.0;

   //burn the players?
   playerBurnTime = 5000;

};

datablock ProjectileData(NeotankExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = NeotankExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};


datablock ExplosionData(NeotankShellExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = gravityRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.9;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 10;
   radiusDamage = 400;

   impulseRadius = 14;
   impulseForce = 6000;

   playerBurnTime = 5000;
};

AddDamageType("NeotankShellDirect",   '<bitmap:add-ons/Projectile_GravityRocket/rocket> %1',    '%2 <bitmap:add-ons/Projectile_GravityRocket/rocket> %1',1,1);
AddDamageType("NeotankShellRadius",   '<bitmap:add-ons/Projectile_GravityRocket/rocketRadius> %1',    '%2 <bitmap:add-ons/Projectile_GravityRocket/rocketRadius> %1',1,0);

datablock ProjectileData(NeotankShellProjectile)
{
   projectileShapeName = "./NeotankBullet.dts";
   directDamage        = 100;
   directDamageType = $DamageType::NeotankShellDirect;
   radiusDamageType = $DamageType::NeotankShellRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = NeotankShellExplosion;
   particleEmitter     = rocketTrailEmitter;

   brickExplosionRadius = 5;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 60;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 120;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = rocketLoopSound;

   muzzleVelocity      = 120;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.5;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 1;

   uiName = "Neotank Shell"; //naming it this way so it's next to the rocket in the alphabetized list
};

package NeotankPackage
{
   function Player::burn(%obj,%time)
   {
      if(%obj.dataBlock $= NeotankPlayer)
         return;
      else
         Parent::burn(%obj,%time);
   }

   function NeotankPlayer::Damage(%data,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle     
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %data.maxDamage && !isObject(%obj.client))
         %obj.setDamageLevel(%data.maxDamage);
      else
         Parent::Damage(%data,%obj,%source,%pos,%amm,%type);
   }

   function armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      %mount = %obj.getObjectMount();

      //hack so we can shoot if we are a Neotank 
      if(%obj.getDataBlock().getID() == NeotankPlayer.getID())
         %mount = %obj;

      if(isObject(%mount))
      {
         if(%mount.getDataBlock() == NeotankPlayer.getId() && %triggerNum == 0 && %val)
         {
            %client = %obj.client;
            if(isObject(%client))
               ServerCmdUnUseTool(%client);

            if(getSimTime() - %obj.lastShotTime < 2500)
               return;
            
            %scaleFactor = getWord(%mount.getScale(), 2);
            %p = new Projectile()
            {
               dataBlock = NeotankShellProjectile;
               initialPosition = %mount.getSlotTransform(1);
               initialVelocity = vectorScale(%mount.getMuzzleVector(1),140 * %scaleFactor);
               sourceObject = %obj;
               client = %obj.client;
               sourceSlot = 0;
               originPoint = %mount.getSlotTransform(1);
            };
            MissionCleanup.add(%p);
            %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);

            %mount.mountImage(TankSmokeImage,1);

            serverPlay3D(TankshotSound,%obj.getPosition());
            
            %obj.playThread(0,activate);
            %obj.lastShotTime = getSimTime();

            return;
         }
      }
      
      Parent::onTrigger(%this,%obj,%triggerNum,%val);
   }
};
activatepackage(NeotankPackage);